var config = require('../config.js');
var protocolStr = "https:";
var serverUrl = config.serverUrl;
// 引入jsencrypt 
var Encrypt = require('../lib/jsencrypt.min'); 
var JSEncrypt = Encrypt.JSEncrypt;
//获取RSA key 长度 
JSEncrypt.prototype.getkeylength = function () {
    return ((this.key.n.bitLength() + 7) >> 3);
};

// 分段解密，支持中文
JSEncrypt.prototype.decryptUnicodeLong = function (string) {
    var k = this.getKey();
    //解密长度=key size.hex2b64结果是每字节每两字符，所以直接*2
    var maxLength = ((k.n.bitLength() + 7) >> 3) * 2;
    try {
        var hexString = b642hex(string);
        var decryptedString = "";
        var rexStr = ".{1," + maxLength + "}";
        var rex = new RegExp(rexStr, 'g');
        var subStrArray = hexString.match(rex);
        if (subStrArray) {
            subStrArray.forEach(function (entry) {
                decryptedString += k.decrypt(entry);
            });
            return decryptedString;
        }
    } catch (ex) {
        return false;
    }
};

// 分段加密，支持中文
JSEncrypt.prototype.encryptUnicodeLong = function (string) {
    var k = this.getKey();
    //根据key所能编码的最大长度来定分段长度。key size - 11：11字节随机padding使每次加密结果都不同。
    var maxLength = ((k.n.bitLength() + 7) >> 3) - 11;
    try {
        var subStr = "", encryptedString = "";
        var subStart = 0, subEnd = 0;
        var bitLen = 0, tmpPoint = 0;
        for (var i = 0, len = string.length; i < len; i++) {
            //js 是使用 Unicode 编码的，每个字符所占用的字节数不同
            var charCode = string.charCodeAt(i);
            if (charCode <= 0x007f) {
                bitLen += 1;
            } else if (charCode <= 0x07ff) {
                bitLen += 2;
            } else if (charCode <= 0xffff) {
                bitLen += 3;
            } else {
                bitLen += 4;
            }
            //字节数到达上限，获取子字符串加密并追加到总字符串后。更新下一个字符串起始位置及字节计算。
            if (bitLen > maxLength) {
                subStr = string.substring(subStart, subEnd)
                encryptedString += k.encrypt(subStr);
                subStart = subEnd;
                bitLen = bitLen - tmpPoint;
            } else {
                subEnd = i;
                tmpPoint = bitLen;
            }
        }
        subStr = string.substring(subStart, len)
        encryptedString += k.encrypt(subStr);
        return hex2b64(encryptedString);
    } catch (ex) {
        return false;
    }
};

function hex2b64(h) {
    var b64map = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var b64padchar = "=";
    var i;
    var c;
    var ret = "";
    for (i = 0; i + 3 <= h.length; i += 3) {
        c = parseInt(h.substring(i, i + 3), 16);
        ret += b64map.charAt(c >> 6) + b64map.charAt(c & 63);
    }
    if (i + 1 == h.length) {
        c = parseInt(h.substring(i, i + 1), 16);
        ret += b64map.charAt(c << 2);
    }
    else if (i + 2 == h.length) {
        c = parseInt(h.substring(i, i + 2), 16);
        ret += b64map.charAt(c >> 2) + b64map.charAt((c & 3) << 4);
    }
    while ((ret.length & 3) > 0) ret += b64padchar;
    return ret;
}

function b642hex(s) {
    var b64map = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var b64padchar = "=";
    var b64pad = '=';
    var ret = '';
    var i;
    var k = 0; // b64 state, 0-3
    var slop = 0;
    for (i = 0; i < s.length; ++i) {
        if (s.charAt(i) === b64pad) {
            break;
        }
        var v = b64map.indexOf(s.charAt(i));
        if (v < 0) {
            continue;
        }
        if (k === 0) {
            ret += int2char(v >> 2);
            slop = v & 3;
            k = 1;
        } else if (k === 1) {
            ret += int2char((slop << 2) | (v >> 4));
            slop = v & 0xf;
            k = 2;
        } else if (k === 2) {
            ret += int2char(slop);
            ret += int2char(v >> 2);
            slop = v & 3;
            k = 3;
        } else {
            ret += int2char((slop << 2) | (v >> 4));
            ret += int2char(v & 0xf);
            k = 0;
        }
    }
    if (k === 1) {
        ret += this.int2char(slop << 2);
    }
    return ret;
}
function int2char(n) {
	var BI_RM = '0123456789abcdefghijklmnopqrstuvwxyz'
    return BI_RM.charAt(n);
}
var enInstance = new JSEncrypt(); 
//加密
function enParams(data){
	enInstance.setPublicKey('MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCZrka+AYhh0bqog0k6jFzYO7mqGMxYx1nqO1ARh+tnYVicj41xc0URPg1hU8UUkPDFH57bhXqTjKDKTkIWortLfvsQMDh1jNMbM9QI3BoQvzf9XNuImzqyR1cjvj9U05sGwt8JHiQgmAZlH/OUzDy7/QJ3iJaSxuOpztfOnTtGswIDAQAB')
	return enInstance.encrypt(data);
}
//解密
function deParams(data) {
	enInstance.setPrivateKey('MIICXQIBAAKBgQCZrka+AYhh0bqog0k6jFzYO7mqGMxYx1nqO1ARh+tnYVicj41xc0URPg1hU8UUkPDFH57bhXqTjKDKTkIWortLfvsQMDh1jNMbM9QI3BoQvzf9XNuImzqyR1cjvj9U05sGwt8JHiQgmAZlH/OUzDy7/QJ3iJaSxuOpztfOnTtGswIDAQABAoGADmEUFWsnS5/IC0RdcbD4bvMHqDaxyAy/CP+LulgxWnbtR5jW7y    qN59MahWTFJ+t327ndr0SJ94xM7yDrZhrL01trsEjl5LK2aWzYGJg1poJYiSiKY5lyVOFE8AWsiWk3fC9Yp2ZabBB4hh3foqfOMD41oygHOYm7Yngp7VWQiUECQQDIJoODv7LJNfsPOhxyGMcuhSCrL4A/m9Vib72GFTQ5BmCpbmpoU+N9xO3dAiGwXGMXjWSvQP9FL3KbUUBjUHU7AkEAxJBDAWFQrsbeNj0uso2dZVIG5fWrrwlOogfosuGGD/BvtWBOmFi8    5fZgyMxa6xRHre/sXv8CLtZGFR3J3Sh86QJACRa2oiTyWXC6Fdbts8CsStCAy0U87aaF6hJo6M3NsUk42njJHDOzAOMQahjOrtODLG6fQ9YPwXSGH8dwxRHCQQJBAJdhIrllYOW5clkDNXt9ZMIrMfTYBqh+2nge7y8UUFLmMKHW0bCyZogT/uWlvD9fFvT12WwvqFa53q9UiaoxDEECQQCttOK4bQmZVRy+UhVKL8B9oySN+Of02ULWEzba9O39MpiI3yvy0A    ikUiJxLU9wFxhBsrx6VEMXPbRcIIdzEynq');
	return enInstance.decryptUnicodeLong(data)
}
module.exports = {
	/**
	 * 加密
	 * @param {*} data 
	 */
	enParams,  
	/**
	 * 解密
	 * @param {*} data 
	 */
	deParams,
	/**
	 * @description 获取token前的验证
	 * @param timeStamp 超时凭证
	 */
	getCertificate: function(timeStamp) {
		if(!timeStamp) console.error("++++getCertificate(), timeStamp is null"); 
		var sdkapiBaseURL = protocolStr + "//" + serverUrl + "/avd2api/v1";  
		return fetchPost(sdkapiBaseURL + '/certificate/get', { 
			data:  enParams(JSON.stringify({
				"access_key": "demo_access",
				"secret_key": "demo_secret",
				"timestamp": timeStamp
			}))
		})
	}, 
  /**
   * 获取访问令牌
   * @param {String} access_key 
   * @param {String} secret_key 
   */
  getAccessToken: function (access_key, secret_key) { 
      var sdkapiBaseURL = protocolStr + "//" + serverUrl + "/sdkapi/v2";
      console.log("++++getAccessToken(),serverUrl:", serverUrl);
      console.log("++++getAccessToken restful URL:" + sdkapiBaseURL + "/app/get_token"); 
    return fetchGet(sdkapiBaseURL+'/app/get_token', { 
          "access_key": access_key, 
          "secret_key": secret_key 
        });
    },  
  /**
   * 创建房间
   * @param {String} token-访问令牌
   * @param {String} topic-会议主题 
   * @param {Boolean} enable_auto_cloud_recording-是否开启云端自动录制，默认false
   * @param {String} user_id-房间创建者用户ID 
   * @param {String} room_id-指定房间ID，如果不传服务器生成随机号
   * @param {Boolean} enable_auto_avc-是否启用自动视频AVC模式（视频合屏），默认false
   */
  createRoom: function (token, topic, user_id, room_id, enable_auto_cloud_recording, enable_auto_avc) {
    var paramsObj = {
      "token": token,
      "topic": topic,
      "user_id": user_id,
    }

    if (room_id) {
      paramsObj.room_id = room_id;
    }

    if (enable_auto_cloud_recording) {
       paramsObj.enable_auto_cloud_recording = enable_auto_cloud_recording;
    }

    if (enable_auto_avc) {
        paramsObj.enable_auto_avc = enable_auto_avc;
    }

    var serverUrl = config.serverUrl;
    console.log("++++createRoom(),serverUrl:", serverUrl);
    var avd2apiBaseURL = protocolStr + "//" + serverUrl + "/sdkapi/v2"
    console.log("++++createRoom restful URL:" + avd2apiBaseURL + "/room/create");

    return fetchGet(avd2apiBaseURL + '/room/create', paramsObj);
  },





  /**
   * 更新实时验证令牌token和会话isession_id
   * module：system/系统模块, 错误码区间:10200
   */
  authRefresh: function(session_id, room_token) {
    var serverUrl = config.serverUrl;
    console.log("++++authRefresh(),serverUrl:", serverUrl);
    var avd2apiBaseURL = protocolStr + "//" + serverUrl + "/avd2api/v1"
    console.log("++++authRefresh restful URL:" + avd2apiBaseURL + "/auth/refresh");

    return fetchGet(avd2apiBaseURL + "/auth/refresh", {
      "session_id": session_id,
      "room_token": room_token
    });
  },


  /**
   * 登录
   * 访问URL: auth/login
   * 错误码区间:10100-10199
   */
  userLogin: function(email, password) {
    var serverUrl = config.serverUrl;
    console.log("++++userLogin(),serverUrl:", serverUrl);
    var avd2apiBaseURL = protocolStr + "//" + serverUrl + "/avd2api/v1"
    console.log("++++userLogin restful URL:" + avd2apiBaseURL + "/auth/login");
    return fetchGet(avd2apiBaseURL + "/auth/login", {
      "email": email,
      "password": password
    });
  },


  /**
   * 获取房间参数
   * 访问URL: /room/get_room_params
   * module：system/系统模块, 错误码区间:10200
   */
  getRoomParams: function(roomId, sessionId) {
    var serverUrl = config.serverUrl;
    console.log("++++getRoomParams(),serverUrl:", serverUrl);
    var avd2apiBaseURL = protocolStr + "//" + serverUrl + "/avd2api/v1"
    console.log("++++getRoomParams restful URL:" + avd2apiBaseURL + "/room/get_room_params");
    sessionId = sessionId ? sessionId : '';
    return fetchGet(avd2apiBaseURL + "/room/get_room_params", {
      "room_id": roomId,
      "session_id": sessionId
    });
  },

  /**
   * 游客获取房间token
   * 访问URL: auth/get_room_token
   * 错误码区间:10100-10199
   */
  getVisitoRoomToken: function(roomId, userName) {
    var serverUrl = config.serverUrl;
    console.log("++++getVisitoRoomToken(),serverUrl:", serverUrl);
    var avd2apiBaseURL = protocolStr + "//" + serverUrl + "/avd2api/v1"
    console.log("++++getVisitoRoomToken restful URL:" + avd2apiBaseURL + "/auth/get_room_token");
    return fetchGet(avd2apiBaseURL + "/auth/get_room_token", {
      "room_id": roomId,
      "name": userName
    });
  }
}

/**
 * 自定义get函数，返回Promise
 * @param { String } url 接口网址
 * @param { arrayObject } data 要传的数组对象 例如: { name: '武当山道士', age: 32 }
 * @return { Promise }    promise 返回promise供后续操作
 */
function fetchGet(url, data, thirdRsetful) {
  var promise = new Promise((resolve, reject) => {
    var that = this;
    var getData = data;

    /*
    //自动添加签名字段到getData，makeSign(obj)是一个自定义的生成签名字符串的函数
    getData.signature = that.makeSign(getData);
    */

    //网络请求
    wx.request({
      url: url,
      data: getData,
      method: 'GET',
      header: {
        'content-type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        if (thirdRsetful) {
          if (res.data.errcode) {
            reject(res.data);
          } else {
            resolve(res.data);
          }
        } else {
          if (res.data.ret === 0) {
            resolve(res.data);
          } else {
            reject(res.data);
          } 
        }
      },
      error: function(e) {
        var error = {};
        if (e.response) {
          error = new Error(e.response.status, e.response.data);
        } else {
          error = new Error(10000, e.message);
        }
        reject(error);
      }
    })
  });
  return promise;
};


/**
 * 自定义post函数，返回Promise
 * @param { String } url 接口网址
 * @param { arrayObject } data 要传的数组对象 例如: { name: '武当山道士', age: 32 }
 * @return { Promise }    promise 返回promise供后续操作
 */
function fetchPost(url, data, thirdRsetful) {
  var promise = new Promise((resolve, reject) => {
    var that = this;
    var postData = data;

    /*
    //自动添加签名字段到postData，makeSign(obj)是一个自定义的生成签名字符串的函数
    // postData.signature = that.makeSign(postData);
    */

    //网络请求
    wx.request({
      url: url,
      data: postData,
      method: 'POST',
      responseType: 'text',
      header: {
        'content-type': 'application/x-www-form-urlencoded;charset=UTF-8'
      },
      success: function(res) { 
        if (thirdRsetful) {
          if (res.data.errcode) {
            reject(res.data);
          } else {
            resolve(res.data);
          }
        } else {
          if (res.data.ret === 0 || res.ret == 0) {
            resolve(res.data);
          } else {
            reject(res.data);
          }
        }
      },
      error: function(e) {
        var error = {};
        if (e.response) {
          error = new Error(e.response.status, e.response.data);
        } else {
          error = new Error(10000, e.message);
        }
        reject(error);
      }
    })
  });
  return promise;
};

function Error(object, message) {
  this.error = {};

  if (typeof (object) == "object" && typeof (message) == 'undefined') {
    this.error.code = object.code;
    this.error.message = object.message;
  } else {
    this.error.code = object;
    this.error.message = message;
  }
}